; I used tasm 3.2 for this - it might not compile in newer versions without
; minor modifications. Also this sourcecode was formated by Dstalker/UCF's 
; ASMFMT
; email the author at: stone@one.se

.model SMALL
.stack 100h
.386

.data         
perstag DB '2nd&mi'			; Personal tag - not used

;---- File management 
input		DB  13 dup (0)		; Space for inputfilename
output  	DB  'output.lst',0 	; Output filename
inputhnd 	DW 0 			; handle of inputfile
outputhnd 	DW 0 			; handle of output file
byteread  	DD 0			; Used to know when to stop decryption

;---- Text and error messages
introtxt DB '  OSCAR 7.0 SERIAL/SITE FILE DECRYPTER  ',10,13
         DB '|   STONE   |',10,13
         DB '                 ',10,13
         DB '                          ',10,13
         DB '                           ',10,13
         DB '                    ',10,13
         DB '',10,13
         DB 'u N I T E D  c R  C K I N G  f O R C E  ',10,13
         DB '[wIN95/NT][oCT 1997]',10,13
	 DB 'Thanks Nelapsi - thou art incredible',10,13,'$'
work     DB 'Working - this might take a while...',10,13,'$'
openerr	 DB  10,13,'An error has occured opening a file - terminating',10,13,'$'
errcrea  DB 10,13,'An error has occured creating output file - terminating',10,13,'$'
usage    DB 'Usage: decrypt.exe <OSCARFILE2DECRYPT>',10,13
	 DB 'Output will be stored in output.lst',10,13
	 DB 'DOS filenames only',10,13,'$';

;---- Decryption strings from OSCAR 7.0
OSCAR  	DB 'OSCAR7.0'
MARIA   DB 'A MARIA FOI A FONTE E NAO VOLTOU'
Cracker DB 'HI CRACKER!YOU HAVE FOUND ME'

;---- various counters used by decryption routine
j 	DB 0		
c0 	DB 0		; OSCAR7.0 counter
c1 	DB 0		; crkcaer Counter
c2 	DB 0		; maria counter

BUFFER DB 0ffh dup (?) ; decryption buffer

;-------------
.CODE
	MOV AX, @DATA            		; Make DS&ES point to the DATA
	MOV ES,AX

	XOR    ECX,ECX
	MOV    CL,DS:[80h]
	JCXZ   NoStr			; No parameters given
	MOV    EDI,81h
	ADD    EDI,ECX
	XOR    AL,AL
	STOSB				; Zero terminate string
	MOVZX EBX,CX
	CMP ECX, 13
	JG nostr			; Too long to be a file name
	CALL upcase			; Upcase it
	CALL cleanit			; remove all special chars E.g. Spaces 

	MOV AX, @DATA            	; Make DS&ES point to the DATA
	MOV DS,AX
	MOV ES,AX
	JMP paramok			; Start the actualy program

nostr:
	MOV AX, @DATA            	; Make DS&ES point to the DATA
	MOV DS,AX

	LEA EDX, introtxt		; Write introtxt
	MOV AH,9h
	INT 21h

	MOV AH,9h			; Write usage
	LEA EDX, [usage]
	INT 21h
	
	MOV AX,4c01h			; terminate error code = 1
	INT 21h


paramok:				; the parameters were ok - do yer shit
	LEA EDX, introtxt		; Write introtxt
	MOV AH,9h
	INT 21h

	LEA EDX, work			; Write work
	INT 21h

	LEA EDX, [input]  		; open input file
	MOV AL,0h         		; read only
	CALL open
	MOV inputhnd, BX		; store handle

	CALL crea_OUT	  		; create outputfile

	LEA EDX, [output] 		; open output file
	MOV AL,2h	  		; Read/write
	CALL open
	MOV outputhnd, BX		; store handle

	MOV c0,0			; init counters
	MOV c1,0
	MOV c2,0

nextblock:
	CALL readfile			; read the block
	MOVZX EDI, AX			; this was how many was read
	LEA EBX, [BUFFER]		; let ebx=buffer
	MOV j, 0			; re-init counter
nextloop:
	MOVZX EAX,j
	AND EAX,3
	CMP EAX,0 
	JZ default
	CMP EAX, 1
	JZ decrypt1
	CMP EAX, 2
	JZ decrypt2

	CMP EAX, 3
	JZ decrypt3

decrypt1:
	MOVZX EDX,[c1]
	MOV DL, [CRACKER+EDX]
	XOR BYTE PTR [EBX], DL
	JMP default

decrypt2: 
	MOVZX EDX,[c2]			
	MOV DL, [maria+EDX]	
	XOR BYTE PTR [EBX], DL
	JMP default

decrypt3:
	XOR BYTE PTR [EBX],2
	JMP default

default:
	MOVZX EDX,[c0]			; default
	MOV DL, BYTE PTR [oscar+EDX]	
	XOR BYTE PTR [EBX],DL		

	INC EBX
	INC j
	INC c0
	INC c1
	INC c2
	CMP c0, 8
	JNZ ok1
	MOV c0,0
ok1:	CMP c1, 28
	JNZ ok2
	MOV c1,0
ok2:
	CMP c2, 32
	JNZ ok3
	MOV c2,0
ok3:
	DEC EDI
	JNZ nextloop

	CALL writefile			; write the decrypted
	CMP [byteread],0ffh		; is this the last block?
	JL EXIT				; if so - exit
	JMP nextblock

EXIT:
	CALL closeall			; close all the files
exit2:
	MOV AX,4c00h			; We're Done terminate errorcode = 0
	INT 21h

writefile PROC				; write output.lst
	MOV BX, outputhnd		; fetch handle
	MOV ECX, [byteread]		; write this many bytes
	LEA EDX, [BUFFER]		; write the buffer
	MOV AH,40h
	INT 21h
	RET
writefile ENDP

readfile PROC
	MOV BX, inputhnd		; fetch the handle of inputfile
	MOV ECX,0ffh			; number of bytes to read
	LEA EDX, [BUFFER]	 	; where to read it to
	MOV AH,3fh
	INT 21h
	MOV [byteread],EAX		; this many bytes were actually read
	RET
readfile ENDP

OPEN	PROC				; Open file in edx - return handle in
	MOV AH,3dh			; ebx
	INT 21h
	JC erroropen			; did an error occour?
	XCHG EAX,EBX
	RET
erroropen:				
	LEA EDX, [openerr]		; Write the error message
	MOV AH,9h
	INT 21h

	MOV AX,4c01h			; terminate error code = 1
	INT 21h
	RET
OPEN    ENDP


crea_OUT PROC
	MOV  AX, 3c00h                  ; Create output file
	XOR  CX,CX                      ; no attributes
	LEA  DX, output                 ; with [output] as name
	INT  21h
	JC   creaerr			; was there an error while creating file
	RET
creaerr:
	MOV AH,9h			; write error message
	LEA EDX, [errcrea]
	INT 21h
	
	MOV AX,4c01h			; terminate error code = 1
	INT 21h   
	RET
crea_OUT ENDP

closeall PROC
	MOV BX, inputhnd		; close input file
	MOV AH,3eh
	INT 21h

	MOV AH,3eh			; close output file
	MOV BX, outputhnd
	INT 21h
	RET
closeall ENDP

upcase  PROC				; upcase paramstring
	MOV EDX, 81h
	MOV ESI,EDX
nextletter:           			; EBX = No. of letters
	MOV     AL,[EDX]		; EDX = INTEXT
	CMP     AL,61h
	JB      notlowcase
	CMP     AL,7Ah
	JA      notlowcase
	SUB     AL,20h			; Lowcase - make it upcase
	MOV     [ESI],AL
notlowcase:
	INC     EDX
	INC     ESI
	DEC     EBX
	TEST    EBX,EBX
	JNZ     nextletter
	RET
Upcase ENDP

cleanit PROC				; remove unwanted chars, move 
					; param string to ds:input
					; required input: ecx= length
	LEA EDI, [input]		; Store output here
	MOV ESI, 81h			; Get input from here
nextb:
	MOVZX EAX,BYTE PTR DS:[ESI]	; Fetch a letter
	CMP EAX,44			; Is it low bit?
	JB skip
	CMP EAX,'/'			; this is not high or low bit but stil
					; illegal
	JZ skip
	CMP EAX,91			; is it high bit?
	JG skip
	MOVSB				; no - copy it as it is
	DEC ECX				; move on to next letter
	JNZ nextb
	RET
skip:
	INC ESI				; skip it
	DEC ECX				; next letter
	JNZ nextb
	RET
cleanit ENDP

END
