comment %
	sample usage of EnumerateImport's function.

	%
            

.386P
LOCALS
JUMPS
.MODEL FLAT, STDCALL			; with STDCALL we must reverse the sequence of pushes 
					; before a APIn call. 

include	imghdr.inc
UNICODE = 0				; Needed for w32.inc
INCLUDE W32.inc				; Windows definitions

include writeerr.inc			; Write Associated error code

lp EQU  OFFSET
extrn	GetThreadContext 	: PROC

.DATA
szPathName	db "anigdt.exe",0
FileAttr	dd 0
hExeFile	dd 0
FileOpened	dd 0 
FileSize	dd 0 
FMObjectName	db "2nd&mi",0	; Name of memory object + personal tag.
hFMObject	dd 0 
lpMapOfFile	dd 0 
lpObjTbl	dd 0

.CODE

start:
	;int 3
	call 	CreateFile, offset szPathName, GENERIC_READ + GENERIC_WRITE, \
			    FILE_SHARE_READ + FILE_SHARE_WRITE, 0, 3, \
			    offset FileAttr, 0
	cmp	eax, -1
	jnz	@@Opened
	
	;Call	Writeln, lp szUnableToOpen
	Call	WriteErrorCode
	Call	Terminate, 1

@@Opened:
	mov	[hExeFile], eax
	mov	[FileOpened], TRUE
	
@GetFileSize:  
	call	GetFileSize, dword ptr [hExeFile], 0
	mov 	[FileSize], eax
	call	CreateFileMappingA, hExeFile, NULL, PAGE_READWRITE, 0, eax, offset FMObjectName
	test	eax,eax
	jnz	@@MapViewOfFile

	; call WriteLn, lp szUnableToMapFile
	; call WriteErrorCode
	; call CloseHandle, hExeFile
	;jmp	exit
	
@@MapViewOfFile:
	mov	[hFMObject], eax

	call	MapViewOfFile, dword ptr [hFMObject], FILE_MAP_WRITE + FILE_MAP_READ, 0, 0, 0
	test	eax,eax
	jnz	@@Mapped
	;call	WriteLn, lp szUnableToViewFile
	;call	WriteErrorCode
	;Call	Terminate

@@Mapped:
	mov	[lpMapOfFile], eax

	add 	eax, 03ch	; eax ->lpPEHeader
	mov	ebx, [eax]	; eax -> PE-signature
	add	ebx, [lpMapOfFile]
	cmp	dword ptr [ebx], IMAGE_NT_SIGNATURE	; PE
	JZ	@IsPe
	; Call	WriteLn, lp szNotAValidPE
	; Call	Terminate

@IsPe:
	movzx	eax, [ebx.SizeOfOptionalHeader]
	add	eax, ebx
	add	eax, 24				; PE-header=24 => eax ->first object

	mov	[lpObjTbl], eax			; Objecttable located here


	mov	edx, [ebx+128]			; RVA of .idata
	movzx	ecx, word ptr [ebx.NumberOfSections]
	mov	eax, [lpObjTbl]

@@Next:	cmp	[eax], "adi."			; find ".idata"
	jz	@@HERE
	cmp	dword ptr [eax], 0
	jz	Exit
	add	eax, 40
	jmp	@@Next
	
@@HERE:
	mov	edx, [eax.SVirtualAddress]

	mov	eax, [eax.PointerToRawData]



	add	eax, [lpMapOfFile]		; eax -> .idata

	call	EnumerateImports, eax, edx, offset Flaffer



Exit:
	call	ExitProcess, -28




Terminate PROC
arg	ErrorCode:Dword
	cmp	[hExeFile], 0
	jnz	@@NoFileOpen
	call	CloseHandle, dword ptr [hExeFile]
	
@@NoFileOpen:

	call ExitProcess, ErrorCode
	RET
Terminate ENDP

EnumerateImports PROC  STDCALL, lpIDT:dword, rvaIDT:dword, lpCallBack:dword
	local   lpDllName:dword, lpFuncName:dword, IsOrd:dword, rvaIAT:dword


; **** Work Horse
	mov	esi, lpIDT
	mov	edx, esi
	sub	edx, rvaIDT 

@@NextDll:
	mov	eax, [esi+12]			; EAX->rva of dllname
	test	eax,eax
	jz 	@@NoMoreDlls
	add	eax, edx			; account of ImageBase
	mov	lpDllName, eax


	xor	ebx, ebx			; EBX is the number of the function *4
@@NextFunction:
	MOV	IsOrd, TRUE			; Initialize "IsOrd"	
	MOV	eax, [esi]			; RVA of first function
	add	eax, ebx			; add number of function
	add	eax, edx			; account for imagebase
	mov	eax, [eax]			; RVA to name
	test	eax,eax
	jz	@@NoMoreFunctions

	test	eax, 80000000h
	jnz	@@Ordinal

	mov	IsOrd, FALSE
	add	eax, edx			; eax ->name
	inc	eax
	inc	eax
@@Ordinal:
	mov	lpFuncName, eax

; Fetch IAT address of function
	mov	eax, [ESI+16]
	add	eax, ebx
	
	pushad
        call dword ptr [lpCallBack], lpFuncName, lpDllName, rvaIAT, IsOrd
	popad

	add	ebx, 4
	jmp	@@NextFunction
@@NoMoreFunctions:
	add	esi, 20
	jmp	@@NextDll

@@NoMoreDlls:

	ret

EnumerateImports ENDP

Flaffer PROC STDCALL, lpFuncName:dword, lpDllName:dword, rvaIAT:dword, IsOrd:dword

	;int 3
	call MessageBoxA, 0, lpFuncName, lpDllName, 0

	
	ret

Flaffer ENDP
ends
end start
	


