.code
WriteErrorCode PROC
               call     GetLastError
               test     eax,eax
               jnz      @@ErrorCodeFound
               RET

@@ErrorCodeFound:
               cmp 	eax, 12
               jle 	@@KnownError
               mov 	eax, offset UnknownError
               RET
@@KnownError:
               mov 	ebx,4
               mul 	ebx
               add 	eax, offset PtrTbl	
	       mov	eax, [eax]
               RET
WriteErrorCode ENDP



.data
UnknownError db "ERROR_UNKNOWN",0

PtrTbl:
dd offset err1
dd offset err2
dd offset err3
dd offset err4
dd offset err5
dd offset err6
dd offset err7
dd offset err8
dd offset err9
dd offset err10

err1 db "ERROR_INVALID_FUNCTION",0
err2 db "ERROOR_FILE_NOT_FOUND",0
err3 db "ERROR_PATH_NOT_FOUND",0
err4 db "ERROR_TOO_MANY_OPEN_FILES",0
err5 db "ERROR_ACCESS_DENIED",0
err6 db "ERROR_INVALID_HANDLE",0
err7 db "ERROR_ARENA_TRASHED",0
err8 db "ERROR_NOT_ENOUGH_MEMORY",0
err9 db "ERROR_INVALID_BLOCK",0
err10 db "ERROR_BAD_ENVIRONMENT"
err11 db "ERROR_BAD_FORMAT",0
err12 db "ERROR_INVALID_ACCESS",0
comment %
ERROR_INVALID_DATA			equ	  13
ERROR_OUTOFMEMORY			equ	  14
ERROR_INVALID_DRIVE			equ	  15
ERROR_CURRENT_DIRECTORY			equ	  16
ERROR_NOT_SAME_DEVICE			equ	  17
ERROR_NO_MORE_FILES			equ	  18
ERROR_WRITE_PROTECT			equ	  19
ERROR_BAD_UNIT				equ	  20
ERROR_NOT_READY				equ	  21
ERROR_BAD_COMMAND			equ	  22
ERROR_CRC				equ	  23
ERROR_BAD_LENGTH			equ	  24
ERROR_SEEK				equ	  25
ERROR_NOT_DOS_DISK			equ	  26
ERROR_SECTOR_NOT_FOUND			equ	  27
ERROR_OUT_OF_PAPER			equ	  28
ERROR_WRITE_FAULT			equ	  29
ERROR_READ_FAULT			equ	  30
ERROR_GEN_FAILURE			equ	  31
ERROR_SHARING_VIOLATION			equ	  32
ERROR_LOCK_VIOLATION			equ	  33
ERROR_WRONG_DISK			equ	  34
ERROR_SHARING_BUFFER_EXCEEDED		equ	  36
ERROR_HANDLE_EOF			equ	  38
ERROR_HANDLE_DISK_FULL			equ	  39
ERROR_NOT_SUPPORTED			equ	  50
ERROR_REM_NOT_LIST			equ	  51
ERROR_DUP_NAME				equ	  52
ERROR_BAD_NETPATH			equ	  53
ERROR_NETWORK_BUSY			equ	  54
ERROR_DEV_NOT_EXIST			equ	  55
ERROR_TOO_MANY_CMDS			equ	  56
ERROR_ADAP_HDW_ERR			equ	  57
ERROR_BAD_NET_RESP			equ	  58
ERROR_UNEXP_NET_ERR			equ	  59

ERROR_BAD_REM_ADAP			equ	  60
ERROR_PRINTQ_FULL			equ	  61
ERROR_NO_SPOOL_SPACE			equ	  62
ERROR_PRINT_CANCELLED			equ	  63
ERROR_NETNAME_DELETED			equ	  64
ERROR_NETWORK_ACCESS_DENIED		equ	  65
ERROR_BAD_DEV_TYPE			equ	  66
ERROR_BAD_NET_NAME			equ	  67
ERROR_TOO_MANY_NAMES			equ	  68
ERROR_TOO_MANY_SESS			equ	  69

ERROR_SHARING_PAUSED			equ	  70
ERROR_REQ_NOT_ACCEP			equ	  71
ERROR_REDIR_PAUSED			equ	  72

ERROR_FILE_EXISTS			equ	  80
ERROR_CANNOT_MAKE			equ	  82
ERROR_FAIL_I24				equ	  83
ERROR_OUT_OF_STRUCTURES			equ	  84
ERROR_ALREADY_ASSIGNED			equ	  85
ERROR_INVALID_PASSWORD			equ	  86
ERROR_INVALID_PARAMETER			equ	  87
ERROR_NET_WRITE_FAULT			equ	  88
ERROR_NO_PROC_SLOTS			equ	  89

ERROR_TOO_MANY_SEMAPHORES		equ	 100
ERROR_EXCL_SEM_ALREADY_OWNED		equ	 101
ERROR_SEM_IS_SET			equ	 102
ERROR_TOO_MANY_SEM_REQUESTS		equ	 103
ERROR_INVALID_AT_INTERRUPT_TIME		equ	 104
ERROR_SEM_OWNER_DIED			equ	 105
ERROR_SEM_USER_LIMIT			equ	 106
ERROR_DISK_CHANGE			equ	 107
ERROR_DRIVE_LOCKED			equ	 108
ERROR_BROKEN_PIPE			equ	 109
ERROR_OPEN_FAILED			equ	 110
ERROR_BUFFER_OVERFLOW			equ	 111
ERROR_DISK_FULL				equ	 112
ERROR_NO_MORE_SEARCH_HANDLES		equ	 113
ERROR_INVALID_TARGET_HANDLE		equ	 114
ERROR_INVALID_CATEGORY			equ	 117
ERROR_INVALID_VERIFY_SWITCH		equ	 118
ERROR_BAD_DRIVER_LEVEL			equ	 119
ERROR_CALL_NOT_IMPLEMENTED		equ	 120
ERROR_SEM_TIMEOUT			equ	 121
ERROR_INSUFFICIENT_BUFFER		equ	 122
ERROR_INVALID_NAME			equ	 123
ERROR_INVALID_LEVEL			equ	 124
ERROR_NO_VOLUME_LABEL			equ	 125
ERROR_MOD_NOT_FOUND			equ	 126
ERROR_PROC_NOT_FOUND			equ	 127
ERROR_WAIT_NO_CHILDREN			equ	 128
ERROR_CHILD_NOT_COMPLETE		equ	 129
ERROR_DIRECT_ACCESS_HANDLE		equ	 130
ERROR_NEGATIVE_SEEK			equ	 131
ERROR_SEEK_ON_DEVICE			equ	 132
ERROR_IS_JOIN_TARGET			equ	 133
ERROR_IS_JOINED				equ	 134
ERROR_IS_SUBSTED			equ	 135
ERROR_NOT_JOINED			equ	 136
ERROR_NOT_SUBSTED			equ	 137
ERROR_JOIN_TO_JOIN			equ	 138
ERROR_SUBST_TO_SUBST			equ	 139
ERROR_JOIN_TO_SUBST			equ	 140
ERROR_SUBST_TO_JOIN			equ	 141
ERROR_BUSY_DRIVE			equ	 142
ERROR_SAME_DRIVE			equ	 143
ERROR_DIR_NOT_ROOT			equ	 144
ERROR_DIR_NOT_EMPTY			equ	 145
ERROR_IS_SUBST_PATH			equ	 146
ERROR_IS_JOIN_PATH			equ	 147
ERROR_PATH_BUSY				equ	 148
ERROR_IS_SUBST_TARGET			equ	 149
ERROR_SYSTEM_TRACE			equ	 150
ERROR_INVALID_EVENT_COUNT		equ	 151
ERROR_TOO_MANY_MUXWAITERS		equ	 152
ERROR_INVALID_LIST_FORMAT		equ	 153
ERROR_LABEL_TOO_LONG			equ	 154
ERROR_TOO_MANY_TCBS			equ	 155
ERROR_SIGNAL_REFUSED			equ	 156
ERROR_DISCARDED				equ	 157
ERROR_NOT_LOCKED			equ	 158
ERROR_BAD_THREADID_ADDR			equ	 159
ERROR_BAD_ARGUMENTS			equ	 160
ERROR_BAD_PATHNAME			equ	 161
ERROR_SIGNAL_PENDING			equ	 162
ERROR_MAX_THRDS_REACHED			equ	 164
ERROR_LOCK_FAILED			equ	 167
ERROR_BUSY				equ	 170
ERROR_CANCEL_VIOLATION			equ	 173
ERROR_ATOMIC_LOCKS_NOT_SUPPORTED	equ	 174
ERROR_INVALID_SEGMENT_NUMBER		equ	 180
ERROR_INVALID_ORDINAL			equ	 182
ERROR_ALREADY_EXISTS			equ	 183
ERROR_INVALID_FLAG_NUMBER		equ	 186
ERROR_SEM_NOT_FOUND			equ	 187
ERROR_INVALID_STARTING_CODESEG		equ	 188
ERROR_INVALID_STACKSEG			equ	 189
ERROR_INVALID_MODULETYPE		equ	 190
ERROR_INVALID_EXE_SIGNATURE		equ	 191
ERROR_EXE_MARKED_INVALID		equ	 192
ERROR_BAD_EXE_FORMAT			equ	 193
ERROR_ITERATED_DATA_EXCEEDS_64k		equ	 194
ERROR_INVALID_MINALLOCSIZE		equ	 195
ERROR_DYNLINK_FROM_INVALID_RING		equ	 196
ERROR_IOPL_NOT_ENABLED			equ	 197
ERROR_INVALID_SEGDPL			equ	 198
ERROR_AUTODATASEG_EXCEEDS_64k		equ	 199
ERROR_RING2SEG_MUST_BE_MOVABLE		equ	 200
ERROR_RELOC_CHAIN_XEEDS_SEGLIM		equ	 201
ERROR_INFLOOP_IN_RELOC_CHAIN		equ	 202
ERROR_ENVVAR_NOT_FOUND			equ	 203
ERROR_NO_SIGNAL_SENT			equ	 205
ERROR_FILENAME_EXCED_RANGE		equ	 206
ERROR_RING2_STACK_IN_USE		equ	 207
ERROR_META_EXPANSION_TOO_LONG		equ	 208
ERROR_INVALID_SIGNAL_NUMBER		equ	 209
ERROR_THREAD_1_INACTIVE			equ	 210
ERROR_LOCKED				equ	 212
ERROR_TOO_MANY_MODULES			equ	 214
ERROR_NESTING_NOT_ALLOWED		equ	 215
ERROR_BAD_PIPE				equ	 230
ERROR_PIPE_BUSY				equ	 231
ERROR_NO_DATA				equ	 232
ERROR_PIPE_NOT_CONNECTED		equ	 233
ERROR_MORE_DATA				equ	 234
ERROR_VC_DISCONNECTED			equ	 240
ERROR_INVALID_EA_NAME			equ	 254
ERROR_EA_LIST_INCONSISTENT		equ	 255
ERROR_NO_MORE_ITEMS			equ	 259
ERROR_CANNOT_COPY			equ	 266
ERROR_DIRECTORY				equ	 267
ERROR_EAS_DIDNT_FIT			equ	 275
ERROR_EA_FILE_CORRUPT			equ	 276
ERROR_EA_TABLE_FULL			equ	 277
ERROR_INVALID_EA_HANDLE			equ	 278
ERROR_EAS_NOT_SUPPORTED			equ	 282
ERROR_NOT_OWNER				equ	 288
ERROR_TOO_MANY_POSTS			equ	 298
ERROR_PARTIAL_COPY			equ	 299
ERROR_MR_MID_NOT_FOUND			equ	 317
ERROR_INVALID_ADDRESS			equ	 487
ERROR_ARITHMETIC_OVERFLOW		equ	 534
ERROR_PIPE_CONNECTED			equ	 535
ERROR_PIPE_LISTENING			equ	 536
ERROR_EA_ACCESS_DENIED			equ	 994
ERROR_OPERATION_ABORTED			equ	 995
ERROR_IO_INCOMPLETE			equ	 996
ERROR_IO_PENDING			equ	 997
ERROR_NOACCESS				equ	 998
ERROR_SWAPERROR				equ	 999
ERROR_STACK_OVERFLOW			equ	1001
ERROR_INVALID_MESSAGE			equ	1002
ERROR_CAN_NOT_COMPLETE			equ	1003
ERROR_INVALID_FLAGS			equ	1004
ERROR_UNRECOGNIZED_VOLUME		equ	1005
ERROR_FILE_INVALID			equ	1006
ERROR_FULLSCREEN_MODE			equ	1007
ERROR_NO_TOKEN				equ	1008
ERROR_BADDB				equ	1009
ERROR_BADKEY				equ	1010
ERROR_CANTOPEN				equ	1011
ERROR_CANTREAD				equ	1012
ERROR_CANTWRITE				equ	1013
ERROR_REGISTRY_RECOVERED		equ	1014
ERROR_REGISTRY_CORRUPT			equ	1015
ERROR_REGISTRY_IO_FAILED		equ	1016
ERROR_NOT_REGISTRY_FILE			equ	1017
ERROR_KEY_DELETED			equ	1018
ERROR_NO_LOG_SPACE			equ	1019
ERROR_KEY_HAS_CHILDREN			equ	1020
ERROR_CHILD_MUST_BE_VOLATILE		equ	1021
ERROR_NOTIFY_ENUM_DIR			equ	1022
ERROR_DEPENDENT_SERVICES_RUNNING	equ	1051
ERROR_INVALID_SERVICE_CONTROL		equ	1052
ERROR_SERVICE_REQUEST_TIMEOUT		equ	1053
ERROR_SERVICE_NO_THREAD			equ	1054
ERROR_SERVICE_DATABASE_LOCKED		equ	1055
ERROR_SERVICE_ALREADY_RUNNING		equ	1056
ERROR_INVALID_SERVICE_ACCOUNT		equ	1057
ERROR_SERVICE_DISABLED			equ	1058
ERROR_CIRCULAR_DEPENDENCY		equ	1059
ERROR_SERVICE_DOES_NOT_EXIST		equ	1060
ERROR_SERVICE_CANNOT_ACCEPT_CTRL	equ	1061
ERROR_SERVICE_NOT_ACTIVE		equ	1062
ERROR_FAILED_SERVICE_CONTROLLER_CONNECT	equ	1063
ERROR_EXCEPTION_IN_SERVICE		equ	1064
ERROR_DATABASE_DOES_NOT_EXIST		equ	1065
ERROR_SERVICE_SPECIFIC_ERROR		equ	1066
ERROR_PROCESS_ABORTED			equ	1067
ERROR_SERVICE_DEPENDENCY_FAIL		equ	1068
ERROR_SERVICE_LOGON_FAILED		equ	1069
ERROR_SERVICE_START_HANG		equ	1070
ERROR_INVALID_SERVICE_LOCK		equ	1071
ERROR_SERVICE_MARKED_FOR_DELETE		equ	1072
ERROR_SERVICE_EXISTS			equ	1073
ERROR_ALREADY_RUNNING_LKG		equ	1074
ERROR_SERVICE_DEPENDENCY_DELETED	equ	1075
ERROR_BOOT_ALREADY_ACCEPTED		equ	1076
ERROR_SERVICE_NEVER_STARTED		equ	1077
ERROR_DUPLICATE_SERVICE_NAME		equ	1078
ERROR_END_OF_MEDIA			equ	1100
ERROR_FILEMARK_DETECTED			equ	1101
ERROR_BEGINNING_OF_MEDIA		equ	1102
ERROR_SETMARK_DETECTED			equ	1103
ERROR_NO_DATA_DETECTED			equ	1104
ERROR_PARTITION_FAILURE			equ	1105
ERROR_INVALID_BLOCK_LENGTH		equ	1106
ERROR_DEVICE_NOT_PARTITIONED		equ	1107
ERROR_UNABLE_TO_LOCK_MEDIA		equ	1108
ERROR_UNABLE_TO_UNLOAD_MEDIA		equ	1109
ERROR_MEDIA_CHANGED			equ	1110
ERROR_BUS_RESET				equ	1111
ERROR_NO_MEDIA_IN_DRIVE			equ	1112
ERROR_NO_UNICODE_TRANSLATION		equ	1113
ERROR_DLL_INIT_FAILED			equ	1114
ERROR_SHUTDOWN_IN_PROGRESS		equ	1115
ERROR_NO_SHUTDOWN_IN_PROGRESS		equ	1116
ERROR_IO_DEVICE				equ	1117
ERROR_SERIAL_NO_DEVICE			equ	1118
ERROR_IRQ_BUSY				equ	1119
ERROR_MORE_WRITES			equ	1120
ERROR_COUNTER_TIMEOUT			equ	1121
ERROR_FLOPPY_ID_MARK_NOT_FOUND		equ	1122
ERROR_FLOPPY_WRONG_CYLINDER		equ	1123
ERROR_FLOPPY_UNKNOWN_ERROR		equ	1124
ERROR_FLOPPY_BAD_REGISTERS		equ	1125
ERROR_DISK_RECALIBRATE_FAILED		equ	1126
ERROR_DISK_OPERATION_FAILED		equ	1127
ERROR_DISK_RESET_FAILED			equ	1128
ERROR_EOM_OVERFLOW			equ	1129
ERROR_NOT_ENOUGH_SERVER_MEMORY		equ	1130
ERROR_POSSIBLE_DEADLOCK			equ	1131
ERROR_MAPPED_ALIGNMENT			equ	1132
ERROR_SET_POWER_STATE_VETOED		equ	1140
ERROR_SET_POWER_STATE_FAILED		equ	1141
ERROR_OLD_WIN_VERSION			equ	1150
ERROR_APP_WRONG_OS			equ	1151
ERROR_SINGLE_INSTANCE_APP		equ	1152
ERROR_RMODE_APP				equ	1153
ERROR_INVALID_DLL			equ	1154
ERROR_NO_ASSOCIATION			equ	1155
ERROR_DDE_FAIL				equ	1156
ERROR_DLL_NOT_FOUND			equ	1157
ERROR_BAD_USERNAME			equ	2202
ERROR_NOT_CONNECTED			equ	2250
ERROR_OPEN_FILES			equ	2401
ERROR_ACTIVE_CONNECTIONS		equ	2402
ERROR_DEVICE_IN_USE			equ	2404
ERROR_BAD_DEVICE			equ	1200
ERROR_CONNECTION_UNAVAIL		equ	1201
ERROR_DEVICE_ALREADY_REMEMBERED		equ	1202
ERROR_NO_NET_OR_BAD_PATH		equ	1203
ERROR_BAD_PROVIDER			equ	1204
ERROR_CANNOT_OPEN_PROFILE		equ	1205
ERROR_BAD_PROFILE			equ	1206
ERROR_NOT_CONTAINER			equ	1207
ERROR_EXTENDED_ERROR			equ	1208
ERROR_INVALID_GROUPNAME			equ	1209
ERROR_INVALID_COMPUTERNAME		equ	1210
ERROR_INVALID_EVENTNAME			equ	1211
ERROR_INVALID_DOMAINNAME		equ	1212
ERROR_INVALID_SERVICENAME		equ	1213
ERROR_INVALID_NETNAME			equ	1214
ERROR_INVALID_SHARENAME			equ	1215
ERROR_INVALID_PASSWORDNAME		equ	1216
ERROR_INVALID_MESSAGENAME		equ	1217
ERROR_INVALID_MESSAGEDEST		equ	1218
ERROR_SESSION_CREDENTIAL_CONFLICT	equ	1219
ERROR_REMOTE_SESSION_LIMIT_EXCEEDED	equ	1220
ERROR_DUP_DOMAINNAME			equ	1221
ERROR_NO_NETWORK			equ	1222
ERROR_CANCELLED				equ	1223
ERROR_USER_MAPPED_FILE			equ	1224
ERROR_CONNECTION_REFUSED		equ	1225
ERROR_GRACEFUL_DISCONNECT		equ	1226
ERROR_ADDRESS_ALREADY_ASSOCIATED	equ	1227
ERROR_ADDRESS_NOT_ASSOCIATED		equ	1228
ERROR_CONNECTION_INVALID		equ	1229
ERROR_CONNECTION_ACTIVE			equ	1230
ERROR_NETWORK_UNREACHABLE		equ	1231
ERROR_HOST_UNREACHABLE			equ	1232
ERROR_PROTOCOL_UNREACHABLE		equ	1233
ERROR_PORT_UNREACHABLE			equ	1234
ERROR_REQUEST_ABORTED			equ	1235
ERROR_CONNECTION_ABORTED		equ	1236
ERROR_RETRY				equ	1237
ERROR_CONNECTION_COUNT_LIMIT		equ	1238
ERROR_LOGIN_TIME_RESTRICTION		equ	1239
ERROR_LOGIN_WKSTA_RESTRICTION		equ	1240
ERROR_INCORRECT_ADDRESS			equ	1241
ERROR_ALREADY_REGISTERED		equ	1242
ERROR_SERVICE_NOT_FOUND			equ	1243
ERROR_NOT_AUTHENTICATED			equ	1244
ERROR_NOT_LOGGED_ON			equ	1245
ERROR_CONTINUE				equ	1246
ERROR_ALREADY_INITIALIZED		equ	1247
ERROR_NO_MORE_DEVICES			equ	1248
ERROR_NOT_ALL_ASSIGNED			equ	1300
ERROR_SOME_NOT_MAPPED			equ	1301
ERROR_NO_QUOTAS_FOR_ACCOUNT		equ	1302
ERROR_LOCAL_USER_SESSION_KEY		equ	1303
ERROR_NULL_LM_PASSWORD			equ	1304
ERROR_UNKNOWN_REVISION			equ	1305
ERROR_REVISION_MISMATCH			equ	1306
ERROR_INVALID_OWNER			equ	1307
ERROR_INVALID_PRIMARY_GROUP		equ	1308
ERROR_NO_IMPERSONATION_TOKEN		equ	1309
ERROR_CANT_DISABLE_MANDATORY		equ	1310
ERROR_NO_LOGON_SERVERS			equ	1311
ERROR_NO_SUCH_LOGON_SESSION		equ	1312
ERROR_NO_SUCH_PRIVILEGE			equ	1313
ERROR_PRIVILEGE_NOT_HELD		equ	1314
ERROR_INVALID_ACCOUNT_NAME		equ	1315
ERROR_USER_EXISTS			equ	1316
ERROR_NO_SUCH_USER			equ	1317
ERROR_GROUP_EXISTS			equ	1318
ERROR_NO_SUCH_GROUP			equ	1319
ERROR_MEMBER_IN_GROUP			equ	1320
ERROR_MEMBER_NOT_IN_GROUP		equ	1321
ERROR_LAST_ADMIN			equ	1322
ERROR_WRONG_PASSWORD			equ	1323
ERROR_ILL_FORMED_PASSWORD		equ	1324
ERROR_PASSWORD_RESTRICTION		equ	1325
ERROR_LOGON_FAILURE			equ	1326
ERROR_ACCOUNT_RESTRICTION		equ	1327
ERROR_INVALID_LOGON_HOURS		equ	1328
ERROR_INVALID_WORKSTATION		equ	1329
ERROR_PASSWORD_EXPIRED			equ	1330
ERROR_ACCOUNT_DISABLED			equ	1331
ERROR_NONE_MAPPED			equ	1332
ERROR_TOO_MANY_LUIDS_REQUESTED		equ	1333
ERROR_LUIDS_EXHAUSTED			equ	1334
ERROR_INVALID_SUB_AUTHORITY		equ	1335
ERROR_INVALID_ACL			equ	1336
ERROR_INVALID_SID			equ	1337
ERROR_INVALID_SECURITY_DESCR		equ	1338
ERROR_BAD_INHERITANCE_ACL		equ	1340
ERROR_SERVER_DISABLED			equ	1341
ERROR_SERVER_NOT_DISABLED		equ	1342
ERROR_INVALID_ID_AUTHORITY		equ	1343
ERROR_ALLOTTED_SPACE_EXCEEDED		equ	1344
ERROR_INVALID_GROUP_ATTRIBUTES		equ	1345
ERROR_BAD_IMPERSONATION_LEVEL		equ	1346
ERROR_CANT_OPEN_ANONYMOUS		equ	1347
ERROR_BAD_VALIDATION_CLASS		equ	1348
ERROR_BAD_TOKEN_TYPE			equ	1349
ERROR_NO_SECURITY_ON_OBJECT		equ	1350
ERROR_CANT_ACCESS_DOMAIN_INFO		equ	1351
ERROR_INVALID_SERVER_STATE		equ	1352
ERROR_INVALID_DOMAIN_STATE		equ	1353
ERROR_INVALID_DOMAIN_ROLE		equ	1354
ERROR_NO_SUCH_DOMAIN			equ	1355
ERROR_DOMAIN_EXISTS			equ	1356
ERROR_DOMAIN_LIMIT_EXCEEDED		equ	1357
ERROR_INTERNAL_DB_CORRUPTION		equ	1358
ERROR_INTERNAL_ERROR			equ	1359
ERROR_GENERIC_NOT_MAPPED		equ	1360
ERROR_BAD_DESCRIPTOR_FORMAT		equ	1361
ERROR_NOT_LOGON_PROCESS			equ	1362
ERROR_LOGON_SESSION_EXISTS		equ	1363
ERROR_NO_SUCH_PACKAGE			equ	1364
ERROR_BAD_LOGON_SESSION_STATE		equ	1365
ERROR_LOGON_SESSION_COLLISION		equ	1366
ERROR_INVALID_LOGON_TYPE		equ	1367
ERROR_CANNOT_IMPERSONATE		equ	1368
ERROR_RXACT_INVALID_STATE		equ	1369
ERROR_RXACT_COMMIT_FAILURE		equ	1370
ERROR_SPECIAL_ACCOUNT			equ	1371
ERROR_SPECIAL_GROUP			equ	1372
ERROR_SPECIAL_USER			equ	1373
ERROR_MEMBERS_PRIMARY_GROUP		equ	1374
ERROR_TOKEN_ALREADY_IN_USE		equ	1375
ERROR_NO_SUCH_ALIAS			equ	1376
ERROR_MEMBER_NOT_IN_ALIAS		equ	1377
ERROR_MEMBER_IN_ALIAS			equ	1378
ERROR_ALIAS_EXISTS			equ	1379
ERROR_LOGON_NOT_GRANTED			equ	1380
ERROR_TOO_MANY_SECRETS			equ	1381
ERROR_SECRET_TOO_LONG			equ	1382
ERROR_INTERNAL_DB_ERROR			equ	1383
ERROR_TOO_MANY_CONTEXT_IDS		equ	1384
ERROR_LOGON_TYPE_NOT_GRANTED		equ	1385
ERROR_NT_CROSS_ENCRYPTION_REQUIRED	equ	1386
ERROR_NO_SUCH_MEMBER			equ	1387
ERROR_INVALID_MEMBER			equ	1388
ERROR_TOO_MANY_SIDS			equ	1389
ERROR_LM_CROSS_ENCRYPTION_REQUIRED	equ	1390
ERROR_NO_INHERITANCE			equ	1391
ERROR_FILE_CORRUPT			equ	1392
ERROR_DISK_CORRUPT			equ	1393
ERROR_NO_USER_SESSION_KEY		equ	1394
ERROR_LICENSE_QUOTA_EXCEEDED		equ	1395
ERROR_INVALID_WINDOW_HANDLE		equ	1400
ERROR_INVALID_MENU_HANDLE		equ	1401
ERROR_INVALID_CURSOR_HANDLE		equ	1402
ERROR_INVALID_ACCEL_HANDLE		equ	1403
ERROR_INVALID_HOOK_HANDLE		equ	1404
ERROR_INVALID_DWP_HANDLE		equ	1405
ERROR_TLW_WITH_WSCHILD			equ	1406
ERROR_CANNOT_FIND_WND_CLASS		equ	1407
ERROR_WINDOW_OF_OTHER_THREAD		equ	1408
ERROR_HOTKEY_ALREADY_REGISTERED		equ	1409
ERROR_CLASS_ALREADY_EXISTS		equ	1410
ERROR_CLASS_DOES_NOT_EXIST		equ	1411
ERROR_CLASS_HAS_WINDOWS			equ	1412
ERROR_INVALID_INDEX			equ	1413
ERROR_INVALID_ICON_HANDLE		equ	1414
ERROR_PRIVATE_DIALOG_INDEX		equ	1415
ERROR_LISTBOX_ID_NOT_FOUND		equ	1416
ERROR_NO_WILDCARD_CHARACTERS		equ	1417
ERROR_CLIPBOARD_NOT_OPEN		equ	1418
ERROR_HOTKEY_NOT_REGISTERED		equ	1419
ERROR_WINDOW_NOT_DIALOG			equ	1420
ERROR_CONTROL_ID_NOT_FOUND		equ	1421
ERROR_INVALID_COMBOBOX_MESSAGE		equ	1422
ERROR_WINDOW_NOT_COMBOBOX		equ	1423
ERROR_INVALID_EDIT_HEIGHT		equ	1424
ERROR_DC_NOT_FOUND			equ	1425
ERROR_INVALID_HOOK_FILTER		equ	1426
ERROR_INVALID_FILTER_PROC		equ	1427
ERROR_HOOK_NEEDS_HMOD			equ	1428
ERROR_GLOBAL_ONLY_HOOK			equ	1429
ERROR_JOURNAL_HOOK_SET			equ	1430
ERROR_HOOK_NOT_INSTALLED		equ	1431
ERROR_INVALID_LB_MESSAGE		equ	1432
ERROR_SETCOUNT_ON_BAD_LB		equ	1433
ERROR_LB_WITHOUT_TABSTOPS		equ	1434
ERROR_DESTROY_OBJECT_OF_OTHER_THREAD	equ	1435
ERROR_CHILD_WINDOW_MENU			equ	1436
ERROR_NO_SYSTEM_MENU			equ	1437
ERROR_INVALID_MSGBOX_STYLE		equ	1438
ERROR_INVALID_SPI_VALUE			equ	1439
ERROR_SCREEN_ALREADY_LOCKED		equ	1440
ERROR_HWNDS_HAVE_DIFF_PARENT		equ	1441
ERROR_NOT_CHILD_WINDOW			equ	1442
ERROR_INVALID_GW_COMMAND		equ	1443
ERROR_INVALID_THREAD_ID			equ	1444
ERROR_NON_MDICHILD_WINDOW		equ	1445
ERROR_POPUP_ALREADY_ACTIVE		equ	1446
ERROR_NO_SCROLLBARS			equ	1447
ERROR_INVALID_SCROLLBAR_RANGE		equ	1448
ERROR_INVALID_SHOWWIN_COMMAND		equ	1449
ERROR_NO_SYSTEM_RESOURCES		equ	1450
ERROR_NONPAGED_SYSTEM_RESOURCES		equ	1451
ERROR_PAGED_SYSTEM_RESOURCES		equ	1452
ERROR_WORKING_SET_QUOTA			equ	1453
ERROR_PAGEFILE_QUOTA			equ	1454
ERROR_COMMITMENT_LIMIT			equ	1455
ERROR_MENU_ITEM_NOT_FOUND		equ	1456
ERROR_EVENTLOG_FILE_CORRUPT		equ	1500
ERROR_EVENTLOG_CANT_START		equ	1501
ERROR_LOG_FILE_FULL			equ	1502
ERROR_EVENTLOG_FILE_CHANGED		equ	1503
ERROR_INVALID_USER_BUFFER		equ	1784
ERROR_UNRECOGNIZED_MEDIA		equ	1785
ERROR_NO_TRUST_LSA_SECRET		equ	1786
ERROR_NO_TRUST_SAM_ACCOUNT		equ	1787
ERROR_TRUSTED_DOMAIN_FAILURE		equ	1788
ERROR_TRUSTED_RELATIONSHIP_FAILURE	equ	1789
ERROR_TRUST_FAILURE			equ	1790
ERROR_NETLOGON_NOT_STARTED		equ	1792
ERROR_ACCOUNT_EXPIRED			equ	1793
ERROR_REDIRECTOR_HAS_OPEN_HANDLES	equ	1794
ERROR_PRINTER_DRIVER_ALREADY_INSTALLED	equ	1795
ERROR_UNKNOWN_PORT			equ	1796
ERROR_UNKNOWN_PRINTER_DRIVER		equ	1797
ERROR_UNKNOWN_PRINTPROCESSOR		equ	1798
ERROR_INVALID_SEPARATOR_FILE		equ	1799
ERROR_INVALID_PRIORITY			equ	1800
ERROR_INVALID_PRINTER_NAME		equ	1801
ERROR_PRINTER_ALREADY_EXISTS		equ	1802
ERROR_INVALID_PRINTER_COMMAND		equ	1803
ERROR_INVALID_DATATYPE			equ	1804
ERROR_INVALID_ENVIRONMENT		equ	1805
ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT	equ	1807
ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT	equ	1808
ERROR_NOLOGON_SERVER_TRUST_ACCOUNT	equ	1809
ERROR_DOMAIN_TRUST_INCONSISTENT		equ	1810
ERROR_SERVER_HAS_OPEN_HANDLES		equ	1811
ERROR_RESOURCE_DATA_NOT_FOUND		equ	1812
ERROR_RESOURCE_TYPE_NOT_FOUND		equ	1813
ERROR_RESOURCE_NAME_NOT_FOUND		equ	1814
ERROR_RESOURCE_LANG_NOT_FOUND		equ	1815
ERROR_NOT_ENOUGH_QUOTA			equ	1816
ERROR_INVALID_TIME			equ	1901
ERROR_INVALID_FORM_NAME			equ	1902
ERROR_INVALID_FORM_SIZE			equ	1903
ERROR_ALREADY_WAITING			equ	1904
ERROR_PRINTER_DELETED			equ	1905
ERROR_INVALID_PRINTER_STATE		equ	1906
ERROR_PASSWORD_MUST_CHANGE		equ	1907
ERROR_DOMAIN_CONTROLLER_NOT_FOUND	equ	1908
ERROR_ACCOUNT_LOCKED_OUT		equ	1909
ERROR_INVALID_PIXEL_FORMAT		equ	2000
ERROR_BAD_DRIVER			equ	2001
ERROR_INVALID_WINDOW_STYLE		equ	2002
ERROR_METAFILE_NOT_SUPPORTED		equ	2003
ERROR_TRANSFORM_NOT_SUPPORTED		equ	2004
ERROR_CLIPPING_NOT_SUPPORTED		equ	2005
ERROR_UNKNOWN_PRINT_MONITOR		equ	3000
ERROR_PRINTER_DRIVER_IN_USE		equ	3001
ERROR_SPOOL_FILE_NOT_FOUND		equ	3002
ERROR_SPL_NO_STARTDOC			equ	3003
ERROR_SPL_NO_ADDJOB			equ	3004
ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED	equ	3005
ERROR_PRINT_MONITOR_ALREADY_INSTALLED	equ	3006
ERROR_WINS_INTERNAL			equ	4000
ERROR_CAN_NOT_DEL_LOCAL_WINS		equ	4001
ERROR_STATIC_INIT			equ	4002
ERROR_INC_BACKUP			equ	4003
ERROR_FULL_BACKUP			equ	4004
ERROR_REC_NON_EXISTENT			equ	4005
ERROR_RPL_NOT_ALLOWED			equ	4006
ERROR_NO_BROWSER_SERVERS_FOUND		equ	6118
%
