; Stone's WinIce detection v.000000bugged beta
; None of the methods in here is of my invention. This is just my interpretation
; of these methods. Some of the checks are even what I would describe as the
; same method. For instance method 2 & 8 are variations of each other.
; method 2 & 3 could equally be described as variations
; method 6 & 7 also smells a lot like each other so to speak
; Greats must go to: ACP/UCF, MadMax/PC, The Owl from whom I'm stolen the ideas
; and also ofcause Dom Basil! ;)

.MODEL SMALL
.386p
.CODE

org 100h

start:
		lea edx, intro
		mov ah,9
		int 21h


		mov ax, 160ah		
		int 2fh			; Is windows loaded
		test ax,ax
		jnz nowindows
		jmp testv86
nowindows:
		lea edx, nowindow
		call writeln
		jmp exit

testv86:	smsw ax			; is v86 enabled
		and ax,1
		jz no_v86
		jmp check
no_v86:	
		lea edx, nov86
		call writeln
		jmp exit

check:
;
		lea edx, method1
		call writeln
		mov ebp, 'BCHK'		; This utillizes WinIce's
		mov ax, 04h		; Bounds Checker Interface
		int 3		
		cmp al,4
		jz m1failed
		lea edx, success
		jmp m2

m1failed:
		lea edx, failed

;

m2:		call writeln		; This method utilizes the V86 int68h
		lea edx, method2	; interupt handler of winice
		call writeln
		mov ah,43h
		int 68h
		cmp ax,0f386h
		jnz m2failed
		lea edx, success
		jmp m3
m2failed:       lea edx, failed

;

m3:		call writeln		; This method utilizes the fact
		lea edx, method3	; that WinIce has v86 int 68 handler
		call writeln		; and checks for the opcode sequenze
		xor ax,ax		; at this handler
		mov es,ax
		mov bx, word ptr es:[68h*4]
		mov es, word ptr es:[68h*4+2]
		mov eax, 0f43fc80h
		cmp eax, dword ptr es:[ebx]
		jnz m3failed
		lea edx, success
		jmp m4
m3failed:	lea edx, failed
;

m4:		push cs			; This exploits that the int41h
		pop es			; PMODE handler does not chain
		call writeln		; the v86 handler, instead returns
		lea edx, method4	; directly to the program
		call writeln		; This is perhaps one of the harder
		xor ax,ax		; methods to defend against
		mov es,ax
		mov bx, cs
		lea dx, int41handler
		xchg dx, es:[41h*4]
		xchg bx, es:[41h*4+2]
		in al, 40h
		xor cx,cx
		int 41h
		xchg dx, es:[41h*4]
		xchg bx, es:[41h*4+2]
		cmp cl,al
		jz m4failed
		lea edx, success
		jmp m5		
m4failed:	lea edx, failed
;
m5:	
		call writeln			; This method is somewhat
		lea edx, method5		; similar to method 4
		call writeln			; Except it exploits
						; that winice int41 Pmode ISR
		mov bx, cs			; returns F386 in ax if called
		lea dx, int41handler2		; with ax=04fh
		xchg dx, es:[41h*4]		
		xchg bx, es:[41h*4+2]

		mov ax,4fh
		int 41h
		xchg dx, es:[41h*4]
		xchg bx, es:[41h*4+2]

		cmp ax, 0f386h
		jnz m5failed
		lea edx, success
		jmp m6
m5failed:       lea edx, failed
;
m6:		call writeln			; This exploits that WinIce
		lea edx, method6		; Has a "standard" VxD identity
		call writeln
		xor di,di
		mov es,di
		mov ax, 1684h		
		mov bx, 202h
		int 2fh
		mov ax, es
		add ax, di
		test ax,ax
		jz m6failed
		lea edx, success
		jmp m7
m6failed:	lea edx, failed
;

m7:		call writeln			; This is the same as m6
		lea edx, method7		; however this time it's the
		call writeln			; winice GFX VxD
		xor di,di
		mov es,di
		mov ax, 1684h		
		mov bx, 7a5fh
		int 2fh				; get VxD entry point
		mov ax, es			; is there any entry point?
		add ax, di
		test ax,ax
		jz m7failed
		lea edx, success
		jmp m8
m7failed:	lea edx, failed
;

m8:		call writeln			; this searches the lowmem
		lea edx, method8		; (segment 0) for occurences
		call writeln			; of the string "winice"
		xor ax,ax
		mov es,ax
		lea esi, winice
		call search
		jnc m8success
		lea esi, winice2
		call search
		jnc m8success
		lea edx, failed
		jmp m9
m8success:	lea edx, success
;
m9:		call writeln

exit:
		mov ax, 4c00h
		int 21h

;
writeln PROC
	mov ah,9h
	int 21h
	ret
writeln ENDP
;
int41handler PROC
	mov cl,al
	iret
int41handler ENDP
;
int41handler2 PROC
	iret
int41handler2 ENDP
;
search PROC
	mov al, byte ptr [esi]
	xor ecx,ecx
	dec ecx
	and ecx,0000ffffh
	mov edx, esi
	xor edi,edi
again:	cld
	repnz scasb	
	jnz notfound
	dec edi
	push ecx
	mov ecx, len
	repz cmpsb
	jcxz found	
	mov esi, edx	
	pop ecx
	jmp	again

found:
	pop ecx
	clc
	ret

notfound:
	stc
	ret

search ENDP
;
len equ 6
winice   db 'winice'
winice2  db 'WINICE'
;
method1  db 'Method 1: Int 3 - BCHK                          : $'
method2  db 'Method 2: Int 68h, ah=43h (winice returns F386) : $'
method3  db 'Method 3: Code check at Int 68h vector          : $'
method4  db 'Method 4: Int 41h PMODE handler returns directly: $'
method5  db 'Method 5: Int 41h PMODE handler ax=4F           : $' 
method6  db 'Method 6: WinIce VxD loaded                     : $'
method7  db 'Method 7: WinIce GFX VxD loaded                 : $'
method8  db 'Method 8: String: "winice" in LOWMEM            : $'
method9  db 'Method 9: WinIce in MCB                         : $'

failed   db 'WinIce Not detected',10,13,'$'
success  db 'WinIce detected',10,13,'$'
nowindow db 'This must run under Windows',10,13,'$'
nov86    db 'This must run in v86 mode',10,13,'$'
intro    db 'Stone''s Winice detetector',10,13
	 db 'Yes - there is almost infinate possibillities to detect winice',10,13
	 db 'That doesn''t mean that detecting winice isn''t interesting',10,13,'$'
		end start
